/****************************************************
* Zeus CMD - OpenGL Tutorial 08 : Color and Shading *
* By Grant James (ZEUS)                             *
* http://www.zeuscmd.com                            *
****************************************************/
#include <stdlib.h>
#include <GL/glut.h>

bool shaded = false;

bool fullscreen = false;

bool init()
{
	glClearColor(0.93f, 0.93f, 0.93f, 0.0f);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glViewport(0, 0, 500, 500);
	gluOrtho2D(0.0, 1.0, 0.0, 1.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glShadeModel(GL_FLAT);

	return true;
}

void display()
{
	glClear(GL_COLOR_BUFFER_BIT);

	glBegin(GL_TRIANGLES);
		glColor3f(1.0f, 0.0f, 0.0f);
		glVertex3f(0.25f, 0.25f, 0.0f);
		glColor3f(0.0f, 1.0f, 0.0f);
		glVertex3f(0.75f, 0.25f, 0.0f);
		glColor3f(0.0f, 0.0f, 1.0f);
		glVertex3f(0.25f,  0.75f, 0.0f);
	glEnd();

	glFlush();
	glutSwapBuffers();
}

void keyboard(unsigned char key, int x, int y)
{
	switch(key)
	{
	case 27 : 
		exit(1); break;

	case 's' : 
		shaded = !shaded;
		glShadeModel(shaded ? GL_SMOOTH : GL_FLAT);
		glutPostRedisplay();
		break;
	}
}

void specialKeyboard(int key, int x, int y)
{
	if (key == GLUT_KEY_F1)
	{
		fullscreen = !fullscreen;

		if (fullscreen)
			glutFullScreen();
		else
		{
			glutReshapeWindow(500, 500);
			glutPositionWindow(50, 50);
		}
	}
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);

	glutInitWindowPosition(50, 50);
	glutInitWindowSize(500, 500);

	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
	
	glutCreateWindow("08 - Color and Shading");

	glutDisplayFunc(display);
	glutKeyboardFunc(keyboard);
	glutSpecialFunc(specialKeyboard);

	if (!init())
		return 1;

	glutMainLoop();

	return 0;
}
